<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE topic
  PUBLIC "-//OASIS//DTD DITA Topic//EN" "topic.dtd">
<topic id="DITA-map-set-font-Apache-FOP">
  <title>Set a Font for PDF Output Generated with FO Processor</title>
  <body>
    <p id="p_msv_cgk_54b">When a <xref keyref="glossentry_ditamap"><term>DITA map</term></xref> is transformed to PDF
      using an FO processor and it contains some Unicode characters that cannot be rendered by the
      default PDF fonts, a font that is capable of rendering these characters must be configured and
      embedded in the PDF result.</p>
    <p id="p_nsv_cgk_54b">The settings that must be modified for configuring a font for the built-in FO processor are
      detailed in <xref href="add-font-to-builtin-FOP.dita"/>.</p>
    <section id="dita_ot_pdf_font_mapping">
      <title>DITA-OT PDF Font Mapping</title>
      <p id="p_osv_cgk_54b">The DITA-OT contains a file <filepath><term keyref="glossentry_dita_ot_dir"
          />/plugins/org.dita.pdf2/cfg/fo/font-mappings.xml</filepath> that maps logical fonts used
        in the XSLT stylesheets to physical fonts that will be used by the FO processor to generate
        the PDF output.</p>
      <p id="p_psv_cgk_54b">The XSLT stylesheets used to generate the XSL-FO output contain code like this:</p>
      <codeblock  id="codeblock_qsv_cgk_54b">&lt;xsl:attribute name="font-family"&gt;monospace&lt;/xsl:attribute&gt;</codeblock>
      <p id="p_rsv_cgk_54b">The font-family is defined to be <term>monospace</term>, but
          <term>monospace</term> is just an alias. It is not a physical font name. Therefore,
        another stage in the PDF generation takes this <term>monospace</term> alias and looks in the
          <filepath>font-mappings.xml</filepath>.</p>
      <p id="p_ssv_cgk_54b">If it finds a mapping like this:</p>
      <codeblock  id="codeblock_tsv_cgk_54b">&lt;aliases&gt;
      &lt;alias name="monospace"&gt;Monospaced&lt;/alias&gt;
 &lt;/aliases&gt;</codeblock>
      <p id="p_usv_cgk_54b">then it looks to see if the <term>monospace</term> has a
          <term>logical-font</term> definition and if so, it will use the <term>physical-font</term>
        specified
        there:<codeblock  id="codeblock_vsv_cgk_54b">&lt;logical-font name="Monospaced">
      &lt;physical-font char-set="default">
        &lt;font-face>Courier New, Courier&lt;/font-face>
      &lt;/physical-font>
............
&lt;/logical-font></codeblock></p>
      <note type="important" id="note_wsv_cgk_54b">
        <p id="p_xsv_cgk_54b">If no alias mapping is found for a font-family specified in the XSLT
          stylesheets, the processing defaults to <uicontrol>Helvetica</uicontrol>.</p>
      </note>
    </section>
  </body>
  <related-links>
      <link href="http://www.elovirta.com/2016/02/18/font-configuration-in-pdf2.html" format="html"
        scope="external"/>
  </related-links>
</topic>
